import * as t from 'drizzle-orm/pg-core';
import { timestamps } from '../util';
import { relations } from 'drizzle-orm';
import { competitions } from './competitions';

export const fields = t.pgTable('fields', {
	id: t.serial('id').primaryKey(),
	competition_id: t.integer('competition_id').notNull(),
	name: t.text('name').notNull(),
	description: t.text('description'),
	...timestamps
});

export const fieldsRelations = relations(fields, ({ one }) => ({
	competition: one(competitions, {
		fields: [fields.competition_id],
		references: [competitions.id]
	})
}));

export type Field = typeof fields.$inferSelect;
