import * as t from 'drizzle-orm/pg-core';
import { permissionsToRoles, usersToPermissions } from './schema';
import { relations } from 'drizzle-orm';
import { timestamps } from '../util';

export const permissions = t.pgTable('permission', {
	id: t.serial('id').primaryKey(),
	name: t.text('name').notNull().unique(),
	description: t.text('description').notNull(),
	is_wildcard: t.boolean('is_wildcard').notNull(),
	...timestamps
});

export const permissionsRelations = relations(permissions, ({ many }) => ({
	permissionToRoles: many(permissionsToRoles),
	userToPermissions: many(usersToPermissions)
}));

export type Permission = typeof permissions.$inferSelect;
