import { relations } from 'drizzle-orm';
import * as t from 'drizzle-orm/pg-core';
import { matches } from './matches';
import { competitions } from './competitions';
import { schedulingModes } from './schedulingmodes';

export const rounds = t.pgTable('rounds', {
	id: t.serial('id').primaryKey(),
	nb_matches: t.integer('nb_matches').notNull(),
	competition_id: t.integer('competition_id').notNull(),
	scheduling_mode: t.integer('scheduling_mode').notNull()
});

export const roundsRelations = relations(rounds, ({ many, one }) => ({
	competition: one(competitions, {
		fields: [rounds.competition_id],
		references: [competitions.id]
	}),
	matches: many(matches),
	schedulingMode: one(schedulingModes, {
		fields: [rounds.scheduling_mode],
		references: [schedulingModes.id]
	})
}));
