import * as t from 'drizzle-orm/pg-core';
import { timestamps } from '../util';
import { relations } from 'drizzle-orm';
import { rounds } from './rounds';

export const schedulingModes = t.pgTable('scheduling_modes', {
	id: t.serial('id').primaryKey(),
	name: t.text('name').notNull(),
	description: t.text('description'),
	algorithm: t.text('algorithm').notNull(),
	config: t.jsonb('config').notNull(),
	sequence_order: t.integer('sequence_order').notNull(),
	status: t.text('status').notNull(),
	round_id: t.integer('round_id').notNull(),
	...timestamps
});

export const schedulingModesRelations = relations(schedulingModes, ({ one }) => ({
	round: one(rounds, {
		fields: [schedulingModes.round_id],
		references: [rounds.id]
	})
}));

export type SchedulingMode = typeof schedulingModes.$inferSelect;
